//<t>   Header file for ANSI.SYS functions

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_ANSI_H_
#define _DEFD_GD_ANSI_H_ 1


#define MODE_COL_40     1                       // for screen primitives
#define MODE_COL_80     3


#define ANSI_ATTR_DEFAULT       0               // screen attributes
#define ANSI_ATTR_HI_INT        1
#define ANSI_ATTR_UNDLINE       4
#define ANSI_ATTR_BLINK         5
#define ANSI_ATTR_INVERSE       7
#define ANSI_ATTR_BLANK         8
#define ANSI_FG_BLACK           30
#define ANSI_FG_BLUE            34
#define ANSI_FG_GREEN           32
#define ANSI_FG_CYAN            36
#define ANSI_FG_RED             31
#define ANSI_FG_MAGENTA         35
#define ANSI_FG_BROWN           33
#define ANSI_FG_WHITE           37
#define ANSI_BG_BLACK           40
#define ANSI_BG_BLUE            44
#define ANSI_BG_GREEN           42
#define ANSI_BG_CYAN            46
#define ANSI_BG_RED             41
#define ANSI_BG_MAGENTA         45
#define ANSI_BG_BROWN           43
#define ANSI_BG_WHITE           47


#define ANSI_BEEP()                     printf("\007")
        // 800 Mz tone for 1/4 second

#define ANSI_CLEARSCREEN()              printf("\033[2J")
#define ANSI_CLS()                      ANSI_CLEARSCREEN()
        // clears the screen and positions cursor at top left corner
#define ANSI_CURSPOS(x,y)               printf("\033[%u;%uH",(x),(y))
#define ANSI_XY(x,y)                    ANSI_CURSPOS(x,y)
        // positions cursor at x = row, y = column
#define ANSI_EOL()                      printf("\033[K")
        // erases to end of line, including cursor position
#define ANSI_XYEOL(x,y)                 printf("\033[%u;%uH\033[K",(x),(y))
        // positions cursor at x,y then erases to end of line

#define ANSI_SETDISPLAY(a,b,c)          printf("\033[%u;%u;%um",a,b,c)
        // set screen display attributes and colors = (a,b,c) any order:
        // 0 = default, 1 = high intensity, 4 = underline,
        // 5=blinking,7=inverse,8=invisible (black-on-black),30=foreground black,
        // 31=fore red,32=fore green,33=fore yellow,34=fore blue,35=fore magenta,
        // 36=fore cyan,37=fore white,40=background black,41=back red,42=back green,
        // 43=back yellow,44=back blue,45=back magenta,46=back cyan,47=back white.
#define ANSI_HILITE_ON()                printf("\033[%um",ANSI_ATTR_HI_INT)
        // set high light (high intensity) on
#define ANSI_BLINK_ON()                 printf("\033[%um",ANSI_ATTR_BLINK)
        // set blinking on
#define ANSI_HILITE_OFF()               printf("\033[%um",ANSI_ATTR_DEFAULT)
#define ANSI_BLINK_OFF()                ANSI_HILITE_OFF()
        // set high intensity, blink (and all other display attributes) to off


//      function prototypes
BOOL    ansi_cls(int nLines,FILE * wherePrint);


#endif  // avoid duplicate definition
