//<t>   Data Structures for Disk Access using DOS function calls

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.

//      These are various data structures for use with
//      Microsoft MS-DOS function calls to access machine specifics.

//      Compiler: Microsoft C
//      Options : /Zp (pack arrays)
//                /Ze (support "far" extension)


#ifndef _DEFD_GD_DISK_H_
#define _DEFD_GD_DISK_H_ 1


//  dd_header -- layout of DOS device driver header
struct dd_header
{
    struct dd_header FAR *link; // chain to next header
    int  attributes ;           // device attributes
    int  strategy_ad ;          // strategy routine addr
    int  interrupt_ad ;         // interrupt routine addr
    char name[8] ;              // device name field
};


//  disk_table -- layout of table returned by fn 32
struct disk_table
{
    char designator;            // PD
    char alt_designator;        // As above; 0 if RAMdisk
    unsigned sector_size;       // BPS
    char cluster_size;          // SPC - 1
    char heads;                 // NH  - 1
    unsigned fat_start;         // RS
    char fat_copies;            // CF
    unsigned max_entries;       // D
    unsigned first_sector;      // FUS
    unsigned last_cluster;      // TCC + 1
    unsigned char fat_size;     // SPF
    unsigned dir_start;         // FDS
    struct dd_header FAR *ddh;  // DDA
    unsigned media_type;        // MD
    struct disk_table FAR *nxt; // chain to next disk_table
    unsigned subdir_cluster;    // CWD cluster (DOS 2 only)
    char subdirectory[64];      // CWD         (DOS 2 only)
};


//      boot - layout of beginning of DOS boot record
struct boot
{
    unsigned char jump[3];
    unsigned char oem_name[8];          // OEM
    unsigned bytes_per_sector;          // BPS
    unsigned char sectors_per_au;       // SPC
    unsigned reserved_sectors;          // RS
    unsigned char number_of_fats;       // CF
    unsigned number_of_entries;         // D
    unsigned number_of_sectors;         // TS
    unsigned char media_descriptor;     // MD
    unsigned fat_size;                  // SPF
    unsigned sectors_per_track;         // SPT
    unsigned number_of_heads;           // NH
    unsigned hidden_sectors;            // HS
};


#endif  // avoid duplicate definition
