//<t>   Definitions for Full-screen menus

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_FMENU_H_
#define _DEFD_GD_FMENU_H_ 1


#define M1_VPAR     struct  M1_var_par
M1_VPAR
{
        UCHAR       prom[76+1];         //  prompt
        UCHAR       var [ 2+1];         //  variable: %1 to %9
        UCHAR       defl[76+1];         //  default
        M1_VPAR     *next;              //  next entry
};


#define M1_BATCH    struct  M1_m_batch
M1_BATCH
{
        UCHAR       text[76+1];         //  line for batch file
        M1_BATCH    *next;              //  next entry
};


#define M1_HELP     struct  M1_m_help
M1_HELP
{
        UCHAR       text[76+1];         //  line of text for help
        M1_HELP     *next;              //  next entry
};


#define M1_LIST     struct  M1_menu_list
M1_LIST
{
        UCHAR       desc[32+1];         //  description shown on screen
        UCHAR       file[ 8+1];         //  name of file or program
        UCHAR       pass[10+1];         //  password
        UCHAR       pdir[MAX_PATH_LEN]; //  program directory
        UCHAR       ddir[MAX_PATH_LEN]; //  data directory
        UCHAR       type;               //  entry type
        UCHAR       wait;               //  wait for key w=wait/a=auto ret.
        UCHAR       fpar[76+1];         //  fixed parameters (1 only)
        M1_VPAR     *vpar;              //  variable parameters
        M1_BATCH    *batch;             //  batch lines
        M1_HELP     *help;              //  help text
        M1_LIST     *prev;              //  previous entry
        M1_LIST     *next;              //  next entry
};


#define M1_HEADER   struct  M1_menu_header
M1_HEADER
{
        UCHAR       ln_1[70+1];         //  title line 1
        UCHAR       ln_2[70+1];         //  title line 2
        INT16       entries;            //  # of detail entries
        INT16       curr;               //  # of current entry
        M1_LIST     *first;             //  ptr to first detail entry
};


#define END_OF_REC              '\x09'
#define END_OF_FLD              '\x08'
#define END_OF_VAR_FLD          '\x04'
#define REC_TYPE_HEADER         1
#define REC_TYPE_DETAIL         2
#define MAX_MENU_ENTRIES        36
#define TURN_MENU_ON            TRUE
#define TURN_MENU_OFF           FALSE
#define BOX_FOR_MENU            1
#define BOX_FOR_HELP            2

#define MEN_BUF_LEN 2048                  //  ???

INT16   AddFullMenuDetail(M1_HEADER **mhdr,M1_LIST **first_det,M1_LIST **curr_det,UCHAR *desc,UCHAR *file,UCHAR *pass,UCHAR *pdir,UCHAR *ddir,UCHAR type,UCHAR wait,UCHAR *fpar);
INT16   AddFullMenuHelp(M1_LIST **curr_det,UCHAR *help_line);
INT16   fm_ShowHelp(M1_HEADER **mhdr,M1_LIST **mdet);
INT16   InitFullMenu(M1_HEADER **mhdr,M1_LIST **mdet);
FLAG    ShowFullMenu(M1_HEADER **mhdr,M1_LIST **first_det,INT16 curr,BOOL restore_after);


#endif  // avoid duplicate definition
