//<t>   Keyboard Stuff

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_KB_H_
#define _DEFD_GD_KB_H_  1


#define ROM_BIOS_KEYBOARD_FLAG  (((MEM)(0x0000L << 16 )) + 0x0417L)
#define KB_SET_STATE_OFF        0
#define KB_SET_STATE_ON         1
#define KB_SET_STATE_FLIP       2
#define KB_CAPS                 6
#define KB_NUMLOCK              5
#define KB_SCRLOCK              4


//      Keyboard Codes returned by GetKey()
                                        //  Control Codes 1 to 31
#define         CTRL_A          1       //  Control-A:  SOH
#define         CTRL_B          2       //  Control-B:  STX
#define         CTRL_C          3       //  Control-C:  ETX
#define         CTRL_D          4       //  Control-D:  EOT
#define         CTRL_E          5       //  Control-E:  ENQ
#define         CTRL_F          6       //  Control-F:  ACK
#define         CTRL_G          7       //  Control-G:  BEL
#define         CTRL_H          8       //  Control-H:  BS
#define         BACKSP          8
#define         CTRL_I          9       //  Control-I:  HT or TAB
#define         CTRL_J          10      //  Control-J:  LF
#define         CTRL_K          11      //  Control-K:  VT
#define         CTRL_L          12      //  Control-L:  FF
#define         CTRL_M          13      //  Control-M:  CR
#define         RETURN          13      //  Carriage Return / Enter
#define         CTRL_N          14      //  Control-N:  SO
#define         CTRL_O          15      //  Control-O:  SI
#define         CTRL_P          16      //  Control-P:  DLE
#define         CTRL_Q          17      //  Control-Q:  DC1
#define         CTRL_R          18      //  Control-R:  DC2
#define         CTRL_S          19      //  Control-S:  DC3
#define         CTRL_T          20      //  Control-T:  DC4
#define         CTRL_U          21      //  Control-U:  NAK
#define         CTRL_V          22      //  Control-V:  SYN
#define         CTRL_W          23      //  Control-W:  ETB
#define         CTRL_X          24      //  Control-X:  CAN
#define         CTRL_Y          25      //  Control-Y:  EM
#define         CTRL_Z          26      //  Control-Z:  SUB
#define         ESCAPE          27      //  Escape
#define         C_RIGHT         28      //  Cursor Right
#define         C_LEFT          29      //  Cursor Left
#define         C_UP            30      //  Cursor Up
#define         C_DOWN          31      //  Cursor Down
#define         CTRL_BACKSP     127     //  Ctrl-BackSpace

                                        //  Extended Codes, returned as neg.
#define         REG_F1          -59     //  Regular Function Keys
#define         REG_F2          -60
#define         REG_F3          -61
#define         REG_F4          -62
#define         REG_F5          -63
#define         REG_F6          -64
#define         REG_F7          -65
#define         REG_F8          -66
#define         REG_F9          -67
#define         REG_F10         -68
#define         SH_F1           -84     //  Shifted Function Keys
#define         SH_F2           -85
#define         SH_F3           -86
#define         SH_F4           -87
#define         SH_F5           -88
#define         SH_F6           -89
#define         SH_F7           -90
#define         SH_F8           -91
#define         SH_F9           -92
#define         SH_F10          -93
#define         CTRL_F1         -94     //  Control Function Keys
#define         CTRL_F2         -95
#define         CTRL_F3         -96
#define         CTRL_F4         -97
#define         CTRL_F5         -98
#define         CTRL_F6         -99
#define         CTRL_F7         -100
#define         CTRL_F8         -101
#define         CTRL_F9         -102
#define         CTRL_F10        -103
#define         ALT_F1          -104    //  Alt. Function Keys
#define         ALT_F2          -105
#define         ALT_F3          -106
#define         ALT_F4          -107
#define         ALT_F5          -108
#define         ALT_F6          -109
#define         ALT_F7          -110
#define         ALT_F8          -111
#define         ALT_F9          -112
#define         ALT_F10         -113

#define         BACK_TAB        -15     //  Shifted Tab, or "Back Tab"
#define         CURS_UP         -72
#define         CURS_DOWN       -80
#define         CURS_LEFT       -75
#define         CURS_RIGHT      -77
#define         HOME            -71
#define         END             -79
#define         PGUP            -73
#define         PGDN            -81
#define         INSERT          -82
#define         DELETE          -83
#define         CTRL_PRTSC      -114
#define         CTRL_CLEFT      -115
#define         CTRL_CRIGHT     -116
#define         CTRL_HOME       -119
#define         CTRL_END        -117
#define         CTRL_PGUP       -132
#define         CTRL_PGDN       -118
#define         CTRL_BACKSP     127
#define         CTRL_BREAK      -3      //  Control-Break

#define         ALT_A           -30
#define         ALT_B           -48
#define         ALT_C           -46
#define         ALT_D           -32
#define         ALT_E           -18
#define         ALT_F           -33
#define         ALT_G           -34
#define         ALT_H           -35
#define         ALT_I           -23
#define         ALT_J           -36
#define         ALT_K           -37
#define         ALT_L           -38
#define         ALT_M           -50
#define         ALT_N           -49
#define         ALT_O           -24
#define         ALT_P           -25
#define         ALT_Q           -16
#define         ALT_R           -19
#define         ALT_S           -31
#define         ALT_T           -20
#define         ALT_U           -22
#define         ALT_V           -47
#define         ALT_W           -17
#define         ALT_X           -45
#define         ALT_Y           -21
#define         ALT_Z           -44
#define         ALT_1           -120
#define         ALT_2           -121
#define         ALT_3           -122
#define         ALT_4           -123
#define         ALT_5           -124
#define         ALT_6           -125
#define         ALT_7           -126
#define         ALT_8           -127
#define         ALT_9           -128
#define         ALT_0           -129
#define         ALT_MINUS       -130
#define         ALT_EQ          -131


//      Function prototypes

void    kb_set_NumLock(FLAG action);
void    kb_set_CapsLock(FLAG action);
void    kb_set_ScrollLock(FLAG action);
int     kb_stuff_keys(char *string);
int     kb_Break(INT16);                        // Assembler routine
INT16   kb_caps_lock(void);
UINT16  kb_Fetch(void);                         // Assembler routine
INT16   kb_getkey(void);
INT16   kb_getkey_(void);
INT16   kb_getkey_nowait(void);
int     kb_Hit(void);                           // Assembler routine
void    kb_idle_clock(void);
void    kb_idle_install(void (*func)(void));
void    kb_idle_remove(void);
void    kb_idle_reset(INT32 secs);
void    kb_idle_time(void);
void    kb_idle_time_n_blank(void);
INT16   kb_Insert(void);
INT16   kb_num_lock(void);
INT16   kb_scroll_lock(void);
UINT16  kb_Shift(void);                         // Assembler routine


//void    kb_idle_clock(void);
//void    kb_idle_install(void (*func)(void));
//void    kb_idle_remove(void);
//void    kb_idle_reset(INT32 secs);
//void    kb_idle_time(void);
//void    kb_idle_time_n_blank(void);

extern  void    (*kb_idle_)(void);              // kb interrupt handler


#endif  // avoid duplicate definition
