//<t>   Header File for GD Macros

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_MACS_H_
#define _DEFD_GD_MACS_H_ 1

//              NEW FUNCTION NAMES
//      alias (old name)        real name
//      -------------------     ----------
// #define exist_file              fl_exist
//
// #define StripLeadingSpaces      st_ltrim
// #define StripSpaces             st_trim
// #define StripTrailingSpaces     st_rtrim
// #define GetSysDate              dt_getsystemdate
// #define GetSysTime              tm_getsystemtime
//      ----------------------------------

//      Data types
typedef unsigned        BITS ;                  // bit fields
typedef unsigned char   BYTE ;                  // 8-bit byte
typedef signed char     FLAG ;                  // flags usually -1, 0, 1
typedef signed short    RC ;                    // row/column
typedef signed short    COL ;                   // colour
typedef signed short    ATTR ;                  // colour attribute
typedef signed char     SCHAR ;                 // 8-bit char / signed
typedef unsigned char   UCHAR ;                 // 8-bit char / unsigned
typedef unsigned char * STRING ;                // string pointer
typedef signed int      BOOL ;                  // fast integer for TRUE/FALSE and OK/ERROR
typedef signed int      KB ;                    // keystroke
typedef signed int      INT ;                   // integer / signed
typedef signed int      INT16 ;                 // 16-bit integer / signed
typedef unsigned int    UINT ;                  // integer / unsigned
typedef unsigned int    UINT16 ;                // 16-bit integer / unsigned
typedef unsigned int    WORD16 ;                // 16-bit word
typedef signed long     INT32 ;                 // 32-bit integer / signed
typedef signed long     SLONG ;                 // long / signed
typedef unsigned long   UINT32 ;                // 32-bit integer / unsigned
typedef unsigned long   ULONG ;                 // long / unsigned
typedef unsigned long   WORD32 ;                // 32-bit word
typedef unsigned int    NORM_REGISTER ; // eliminate...
typedef unsigned int    FULL_REGISTER ;         // full DOS register, e.g. AX
typedef unsigned char   HALF_REGISTER ;         // half DOS register, e.g. AH or AL


#define NULPTR          ((void*)0)              // null pointer

#define FOREVER         for (;;)
#define UNLESS(e)       if(!e)
        // don't use LOOP with negative increment, use LOOPDOWN
#define LOOP(var,from,to,incr)  for ( (var)=(from) ; (var) <= (to) ; (var)=(var)+(incr) )
#define LOOPDOWN(var,from,to,incr)  for ( (var)=(from) ; (var) > ((to)-1) ; (var)=(var)-(incr) )

#define NOT_GR          <=
#define NOT_LESS        >=
#define MOD             %
#define TRUE            (1)
#define FALSE           (0)
#define YES             TRUE
#define NO              FALSE
#define ON              TRUE
#define OFF             FALSE
#define TO              (2)                     // e.g. SET TO ...
#define DEFAULT         TRUE
#define NOT_DEFAULT     FALSE
#define ERROR           (-1)
#define ABORTED         (-2)
#define NO_ERROR        0
#define OK              0                       // for functions returning a 0 to indicate OK status
#define GOOD_EXIT       0                       // standard exit() code: everything is OK
#define BAD_EXIT        1                       // standard exit() code: problems
#define EOS             '\0'                    // end of string
#define FF              '\f'                    // formfeed
#define FORMFEED        '\f'                    // formfeed
#define NEWLINE         '\n'                    // end of line
#define TAB             '\t'                    // tab character
#define SLASH           '/'                     // / for parameters
#define DASH            '-'                     // - for parameters
#define QUOTE           '\042'                  // quote character
#define ZERO            '0'                     // zero  character
#define SPACE           ' '                     // space character
#define SPACE80         "                                                                                 "
#define BELL            '\007'                  // beep/bell
#define BREAK_OFF       0                       // for kb_Break function
#define BREAK_ON        1
#define FLUSH           TRUE
#define NOFLUSH         FALSE
#define WAIT            TRUE                    // for GetKey function
#define NOWAIT          FALSE
#define SCROLL_UP       ( 0)                    // for ScrollScreen
#define SCROLL_DOWN     ( 1)
#define SCROLL_LEFT     (-1)                    // for ScrollHoriz
#define SCROLL_RIGHT    ( 1)
#define MV_RIGHT        1                       // for MoveCursRelative
#define MV_LEFT         2
#define MV_DOWN         3
#define MV_UP           4
#define GETOPT_END      (-1)                    // for "getopt()"

#define UCHARMIN        (0)
#define UCHARMAX        (255)
#define CHARMIN         (-128)
#define CHARMAX         ( 127)
#define FLAGMIN         (-128)
#define FLAGMAX         ( 127)
#define INT16MIN        (-32768)
#define INT16MAX        ( 32767)
#define UINT16MIN       (0)
#define UINT16MAX       (65535)
#define INT32MIN        (-2147483647L-1L)
#define INT32MAX        ( 2147483647L)
#define UINT32MIN       (0L)
#define UINT32MAX       (4294967295L)

#define MAX_INT         (32767)                 // largest positive integer
#define MAX_U_INT       (65535)                 // largest positive unsigned int.

#define STR_LEN         (256)                   // standard string length

                                                // sizes
#define SZ_kBYTE        (1024)                  // Kilobyte
#define SZ_mBYTE        (SZ_kBYTE*SZ_kBYTE)     // Megabyte
#define SZ_gBYTE        (SZ_kBYTE*SZ_mBYTE)     // Gigabyte
                                                // see _MAX... defined in <stdlib.h>
#define MAX_DOS_PATH_LENGTH 67                  // max allowed by DOS
#define MAX_DRIVE       3                       // all include room for EOS
#define MAX_PATH_LEN    130                     // lengths are 3, 130, 9, and
#define MAX_FNAME       9                       // 5 respectively.
#define MAX_EXT         5
#define FS_LEN          513                     // in NetWare and NT longer than DOS
#define PATH_SEP_CH     '\\'                    // path separator character (\)
#define DRIV_SEP_CH     ':'                     // drive separator character
#define EXT_SEP_CH      '.'                     // ext. separator character
#define REGULAR_FILES   (_A_NORMAL|_A_RDONLY|_A_HIDDEN|_A_SYSTEM|_A_ARCH)
#define ALL_FILES_N_DIRS (_A_NORMAL|_A_RDONLY|_A_HIDDEN|_A_SYSTEM|_A_ARCH|_A_SUBDIR)
#define ALL_FILES       (_A_NORMAL|_A_RDONLY|_A_HIDDEN|_A_SYSTEM|_A_ARCH|_A_VOLID|_A_SUBDIR)
#define STD_INI_FILE    "GD.STD.INI"
#define MAX_ENVVAR_SIZE 256                     // max length of env.var or STD_INI_FILE entry


#ifdef  FOXPRO_FLL                              // FoxPro FLL
//      FoxPro FLL has its own colour definitions
#else
#define BLINK           8                       // add to background
#define BLACK           0
#define BLUE            1
#define GREEN           2
#define CYAN            3
#define RED             4
#define MAGENTA         5
#define BROWN           6
#define WHITE           7
#define GREY            8
#define LT_BLUE         9
#define LT_GREEN        10
#define LT_CYAN         11
#define LT_RED          12
#define LT_MAGENTA      13
#define YELLOW          14
#define BR_WHITE        15
#define DEFAULT_ATTR    (-1)
#endif

#define COLOR_NORMAL    0                       // used by set_color()
#define COLOR_REVERSE   1
#define COLOR_ERROR     2
#define COLOR_WARNING   3
#define COLOR_STATUS    4
#define COLOR_HOLD      5
#define COLOR_WAIT      6
#define COLOR_TT_PGM    7
#define COLOR_TT_TIME   8
#define COLOR_BORDER    9


                                                // DOS Function Calls (INT 21H)
#define GET_DATE        0x2A                    // Get the system date
#define SET_DATE        0x2B                    // Set the system date
#define GET_TIME        0x2C                    // Get the system time
#define SET_TIME        0x2D                    // Set the system time
#define GET_VECTOR      0x35                    // Get interrupt vector address
#define SET_VECTOR      0x25                    // Set interrupt vector address

                                                // BIOS Function Calls
#define PRINT_SCREEN    0x05                    // Print Screen
#define VIDEO_IO        0x10                    // Video I/O operations
#define EQUIPMENT       0x11                    // Equipment Check
#define MEMORY_SIZE     0x12                    // Total memory size
#define DISKETTE_IO     0x13                    // Diskette I/O
#define SERIAL_COMM     0x14                    // Serial Communications I/O
#define KEYBOARD_IO     0x16                    // Keyboard I/O
#define PRINTER_IO      0x17                    // Printer I/O
#define POWER_ON_RESET  0x19                    // Reboot the system
#define DOS_FUNCTION    0x21                    // DOS function call
#define MSCDEX_FUNCTION 0x2F                    // MSCDEX function call
#define MULTIPLEX_FUNCTION 0x2F                 // Multiplex function call


#define MAXCOLUMN       80                      // Maximum Columns on the screen
#define MAXROW          25                      // Maximum Rows (normal text mode)
#define VID_MAX_COLS    132                     // Widest screen supported
#define VID_MAX_ROWS    50                      // Max. lines/screen supported


#define MAX_GLOBAL_1    14
#define MAX_GLOBAL_2    31
#define MAX_GLOBAL_3    73
#define MAX_GLOBAL_4    91
#define PGM_NAME        1
#define PGM_VERS        2
#define PGM_VDAT        3
#define PGM_AUTHOR      4
#define PGM_WRITTEN     5
#define PGM_TITLE       6
#define SYS_TITLE       7
#define SYS_COPRT       8
#define SYS_COP_S       9


#define BYTE2WORD(h,l)  ((h << 8) | (l & 0x00ff))  // Stuff 2 bytes in a word
#define LOBYTE(a)       (a & 0x00ff)            // Get low byte from word
#define HIBYTE(a)       ((a >> 8) & 0x00ff)     // Get high byte from word
#define INRANGE(n,l,h)  ((n >= l) && (n <= h))  // number, low, high
#define OUTRANGE(n,l,h) ((n < l) || (n > h))    // number, low, high
#define ISBITSET(n,wrd) ((wrd >> n) & ~(~0 << 1))  // is bit 'n' set?
// fine CLR_STR(s)      (s[0]='\0')             // clear a string
#define CLR_BLOCK(b)    (memset(&b,0,sizeof(b))) // clear a structure/block

                                                // UCHAR version of toupper
#define UP_UCHAR(_c)    ((unsigned char) ( (islower((unsigned char)_c)) ? ((unsigned char)(((unsigned char)_c)-((unsigned char)'a')+((unsigned char)'A'))) : ((unsigned char)(_c)) ))
#define ST_CPY(t_,s_)   st_cpy(t_,(STRING)s_,sizeof(t_))
#define ST_CAT(t_,s_)   st_cat(t_,s_,sizeof(t_))
#define ST_ZERO(t_)     memset(t_,EOS,sizeof(t_))
#define ST_MOVE(dest,src,cnt)   {memset(dest,EOS,(cnt+1));memmove(dest,src,cnt);}
#define ST_CLR(s)       (s[0]='\0')             // clear a string
#define ST_LASTCHAR(s)  (s[strlen(s)-1])        // get last char in string
#define ST_CLR_LASTCHAR(s) (s[strlen(s)-1]='\0') // set last char in string to EOS
#define ST_EMPTY(s)     (! strlen(s))           // test for empty string

#define ONE_OR_MORE(n)  (n==1 ? "" : "s")       // puts an "s" for plural


#define R_REGS          union _REGS r
#define S_SREGS         struct _SREGS s
INLINE int video_call(union _REGS *r)           // video BIOS call
{
  int ret ;
  union _REGS o ;
  ret = _int86(0x10, r, &o);
  memmove(r,&o,sizeof(o));
  return( ret );
}
#define DOS_CALL(reg)           _int86(DOS_FUNCTION,&reg,&reg)
#define EQUIPMENT_CALL(reg)     _int86(EQUIPMENT,&reg,&reg)
#define KB_CALL(reg)            _int86(KEYBOARD_IO,&reg,&reg)
#define MSCDEX_CALL(reg)        _int86(MSCDEX_FUNCTION,&reg,&reg)
#define MULTIPLEX_CALL(reg)     _int86(MULTIPLEX_FUNCTION,&reg,&reg)
#define PRINTER_CALL(reg)       _int86(PRINTER_IO,&reg,&reg)
#define SERIO_CALL(reg)         _int86(SERIAL_COMM,&reg,&reg)
#define VIDEO_CALL(reg)         _int86(VIDEO_IO,&reg,&reg)

#define INTDOS(reg)             _intdos(&reg,&reg)
#define INTDOSX(reg,sreg)       _intdosx(&reg,&reg,&sreg)

#define _AH             r.h.ah
#define _AL             r.h.al
#define _AX             r.x.ax
#define _BH             r.h.bh
#define _BL             r.h.bl
#define _BX             r.x.bx
#define _CH             r.h.ch
#define _CL             r.h.cl
#define _CX             r.x.cx
#define _DH             r.h.dh
#define _DL             r.h.dl
#define _DX             r.x.dx
#define _DI             r.x.di
#define _SI             r.x.si
#define _DS             s.ds
#define _ES             s.es
#define _CFLAG          r.x.cflag

                                                // Multiplex Function Calls
#define ISLOADED_ANSI()     is_installed(0x1A00) //     0xFF
#define ISLOADED_APPEND()   is_installed(0xB700) //     0xFF
#define ISLOADED_ASSIGN()   is_installed(0x0600) //     0xFF
#define ISLOADED_DOSDOCK()  is_installed(0x2000) //     0xFF
#define ISLOADED_DOSKEY()   is_installed(0x4800) //     (!0)
#define ISLOADED_HIMEM()    is_installed(0x4300) //     0x80
#define ISLOADED_NETWORK()  is_installed(0x1100) //     0xFF
#define ISLOADED_NLSFUNC()  is_installed(0x1400) //     0xFF
#define ISLOADED_PRINT()    is_installed(0x0100) //     0xFF
#define ISLOADED_SHARE()    is_installed(0x1000) //     0xFF

#define LOG_ERR         0                       // Error message
#define LOG_WARN        1                       // Warning message
#define LOG_STAT        2                       // Status message
#define LOG_SECU        3                       // Security
#define LOG_INST        4                       // Installation
#define LOG_ENTR        5                       // Program/func entry
#define LOG_EXIT        6                       // Program/func exit
#define LOG_GENL        7                       // General
#define LOG_DEBG        8                       // Debug information
#define LOG_SCRN        9                       // Screen image dump
#define LOG_MISC        10                      // Miscellaneous

//                                              // global error codes for GD tools
#define GD_ERROR_NONE                   0       // no error, everything OK
#define GD_ERROR_HELP                   1       // no error, but exit via help message
#define GD_ERROR_CANCEL                 2       // no error, but cancelled by program
#define GD_ERROR_USER_CANCEL            3       // no error, but cancelled by user
#define GD_ERROR_INVALID_PARM           10      // invalid parameter
#define GD_ERROR_NO_ANSI_SYS            40      // no ANSI.SYS loaded
#define GD_ERROR_NO_MEMORY              80      // out of memory

#define GD_ERROR_NW_NOT_LOGGED_IN       100     // user is not logged in
#define GD_ERROR_NW_LOGGED_IN           101     // user is logged in
#define GD_ERROR_NW_WS_NO_MEM           102     // workstation out of memory
#define GD_ERROR_NW_SV_NO_MEM           103     // server out of memory

#define GD_ERROR_FILE_NOT_FOUND         200     // no such file
#define GD_ERROR_FILE_ALREADY_EXISTS    201     // user aborted because file already exists
#define GD_ERROR_CANNOT_OPEN_FOR_READ   202     // cannot open file for read operations
#define GD_ERROR_CANNOT_OPEN_FOR_WRITE  203     // cannot open file for write operations
#define GD_ERROR_CANNOT_OPEN_FOR_RW     204     // cannot open file for read/write operations
#define GD_ERROR_FILE_ERROR             205     // general file error
#define GD_ERROR_GENERAL                255     // general/undefined error


                                                // Windows Mode
#define WIN_NOT_ACTIVE                    0     // Windows not active
#define WIN_MODE_ANCIENT                  1     // Windows/386 V2.x running
#define WIN_MODE_REAL                    11     // Windows running in real mode
#define WIN_MODE_STANDARD                12     // Windows running in standard mode
#define WIN_MODE_ENHANCED                21     // Windows running in enhanced mode


#define RETRACE 0x03DA                          // retrace port
INLINE void RETRACE_WAIT(void) { while((_inp(RETRACE)&8)) ; while((_inp(RETRACE)&8)==0) ; }


#endif  // avoid duplicate definition
