//<t>   Full-screen data entry functions

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_SCRN_H_
#define _DEFD_GD_SCRN_H_ 1


#define DTYPE_TEXT_EXT          1       //  All chars from ASCII 032 to 126, 128 to 254
#define DTYPE_TEXT              2       //  All chars from ASCII 032 to 126
#define DTYPE_ALPHA             3       //  Alphabetic only
#define DTYPE_YES_NO            4       //  Y or N
#define DTYPE_FILENAME          5       //  Filename: see sub-type
#define DTYPE_DAY               6       //  Day of the week
#define DTYPE_DATE              7       //  Date
#define DTYPE_TIME              8       //  Time
#define DTYPE_NUMBER            9       //  Number

#define DSTYP_FN_PATH           1       //  Filename:  Complete pathname    size: 63 chars
#define DSTYP_FN_DRV            2       //  Filename:  Drive only           size:  2 chars
#define DSTYP_FN_EXT            3       //  Filename:  Extention only       size:  3 chars
#define DSTYP_FN_NAME           4       //  Filename:  Name only            size:  8 chars
#define DSTYP_FN_DRV_NAME       5       //  Filename:  Drive & name         size: 10 chars
#define DSTYP_FN_NAME_EXT       6       //  Filename:  Name & extention     size: 12 chars
#define DSTYP_FN_DRV_NAME_EXT   7       //  Filename:  Drive, name, & ext.  size: 14 chars

#define DSTYP_DAY_SHORT        21       //  Day: short version              size:  3 chars
#define DSTYP_DAY_LONG         22       //  Day: long version               size:  9 chars

#define DSTYP_DAT_DMY1         41       //  Date: ddmmmyy                   size:  7 chars
#define DSTYP_DAT_DMY2         42       //  Date: dd-mmm-yy                 size:  9 chars
#define DSTYP_DAT_DMY3         43       //  Date: dd-mmm-yyyy               size: 11 chars
#define DSTYP_DAT_DMY4         44       //  Date: dd-mm-yyyy                size: 10 chars
#define DSTYP_DAT_YMD1         51       //  Date: yymmdd                    size:  6 chars
#define DSTYP_DAT_YMD2         52       //  Date: yyyymmdd                  size:  8 chars
#define DSTYP_DAT_YMD3         53       //  Date: yy-mm-dd                  size:  8 chars
#define DSTYP_DAT_YMD4         54       //  Date: yyyy-mm-dd                size: 10 chars
#define DSTYP_DAT_MDY1         61       //  Date: mm/dd/yy                  size:  8 chars
#define DSTYP_DAT_MDY2         62       //  Date: mm/dd/yyyy                size: 10 chars
#define DSTYP_DAT_MTH1         63       //  Date: month only                size:  3 chars
#define DSTYP_DAT_MTH2         64       //  Date: month only                size:  9 chars

#define DSTYP_TIM_24           81       //  Date: 24-hour clock __:__       size:  5 chars
#define DSTYP_TIM_12           82       //  Date: 12-hour clock __:___m     size:  7 chars

#define DSTYP_NUM_FLOAT       101       //  Number: floating decimal
#define DSTYP_NUM_FIXED       102       //  Number: fixed decimal
#define DSTYP_NUM_DOLLARS     103       //  Number: whole dollar amount
#define DSTYP_NUM_DOL_CTS     104       //  Number: dollar & cents amount


#define MASK_CHAR               '_'
#define MASK_CHAR80             "________________________________________________________________________________"
#define MAX_STRING              80
#define MAX_FORM_NAME           12
#define MAX_FORM_FILE           8


#define DISPLAY_AND_ENTER       0
#define DISPLAY_ONLY            1


//      GD full-screen data entry - form header

#define GD_DEH struct data_entry_header         // abbreviation
GD_DEH
{
        UCHAR   file_name[ 9];                  // name of the file (xxxxxxxx.FRM)
        UCHAR   form_name[13];                  // name of the form, max 12 chars.
        INT16   record_type;                    // record identifier: 1
        INT16   form_max;                       // maximum entries in form
        INT16   fld_from;                       // field to read/write from
        INT16   fld_to;                         // field to read/write to
        INT16   fld_current;                    // field pointed to at time of exit
        UCHAR   end_of_record;                  // eor delimiter
};

//      GD full-screen data entry - field

#define GD_DEF struct data_entry_field  // abbreviation
GD_DEF
{
        UCHAR   file_name[ 9];          // name of the file (xxxxxxxx.FRM)
        UCHAR   form_name[13];          // name of the form, max 12 chars.
        INT16   record_type;            // record identifier: 2
        INT16   fnum;                   // field number                        IDENTIFICATION
        RC      prow;                   // row of prompt                       PROMPT
        RC      pcol;                   // column of prompt                    PROMPT
        COL     pfgcol;                 // foreground color of prompt          PROMPT
        COL     pbgcol;                 // background color of prompt          PROMPT
        RC      drow;                   // row of field                        DATA
        RC      dcol;                   // column of field                     DATA
        COL     dfgcol;                 // foreground color of field           DATA
        COL     dbgcol;                 // background color of field           DATA
        INT16   dtype;                  // data type of field                  DATA
        INT16   dsubtype;               // sub-data type of field              DATA
        INT16   maxlen;                 // maximum length of field             DATA
        INT16   numdecimals;            // number of decimals in numeric field DATA
        KB      exitkey;                // key pressed to exit function        RETURN VALUE
        INT16   retdecimals;            // decimals in float data type         RETURN VALUE
        INT16   valu16;                 // 16-bit integer return value         RETURN VALUE
        INT32   valu32;                 // 32-bit integer return value         RETURN VALUE
        double  dbl_valu ;              // double return value                 RETURN VALUE
        BITS    at_reqd         : 1;    // required field                      DATA ATTRIB
        BITS    at_val_chk      : 1;    // user validity check                 DATA ATTRIB
        BITS    at_bounds_chk   : 1;    // check limits                        DATA ATTRIB
        BITS    at_user_help    : 1;    // return req. for help to user        DATA ATTRIB
        BITS    at_security     : 1;    // echo "*" for password               DATA ATTRIB
        BITS    at_field_hold   : 1;    // wait for exit key on full field     DATA ATTRIB
        BITS    at_uppercase    : 1;    // make output uppercase               DATA ATTRIB
        BITS    at_allow_dup    : 1;    // allow duplication from "data"       DATA ATTRIB
        BITS    at_master_dup   : 1;    // allow duplication from "mdup"       DATA ATTRIB
        BITS    at_flush_kb     : 1;    // flush keyboard first                DATA ATTRIB
        BITS    at_allow_esc    : 1;    // allow escape exit                   DATA ATTRIB
        BITS    at_fkey_exit    : 1;    // exit when function key pressed      DATA ATTRIB
        BITS    at_cfkey_exit   : 1;    // exit when ctrl-func key pressed     DATA ATTRIB
        BITS    at_sfkey_exit   : 1;    // exit when sh-func key pressed       DATA ATTRIB
        BITS    at_afkey_exit   : 1;    // exit when alt-func key pressed      DATA ATTRIB
        BITS    at_makebox      : 1;    // make box around the works?          DATA ATTRIB     end of first 16-bit word
        BITS    at_strip_lead   : 1;    // strip leading spaces                DATA ATTRIB
        BITS    at_strip_trail  : 1;    // strip trailing spaces               DATA ATTRIB
        BITS    at_hidden       : 1;    // hide the field?                     DATA ATTRIB
        BITS    at_protected    : 1;    // protect from input (display only)?  DATA ATTRIB
        BITS    at_filler       :12;    // fill to 16 bits                     DATA ATTRIB     end of second 16-bit word
        UCHAR   fname   [21];           // field name, max 20 chars            IDENTIFICATION
        UCHAR   prompt  [MAX_STRING+1]; // prompt string                       PROMPT
        UCHAR   mask    [MAX_STRING+1]; // mask of field                       DATA
        UCHAR   valchars[MAX_STRING+1]; // valid chars                         DATA
        UCHAR   helpmsg [MAX_STRING+1]; // help message                        DATA
        UCHAR   mdup    [MAX_STRING+1]; // master duplication value            DATA
        UCHAR   minvalue[21];           // minimum value for bounds check      DATA
        UCHAR   maxvalue[21];           // maximum value for bounds check      DATA
        UCHAR   data    [MAX_STRING+1]; // in: deflt data, out: entered data   RETURN VALUE
        UCHAR   end_of_record;          // eor delimiter                       END-OF-RECORD
};

//      GD full-screen data entry - text data

#define GD_DET struct data_entry_text           //  Abbreviation
GD_DET
{
        RC      row  ;                          //  row to display text
        RC      col  ;                          //  column to display text
        FLAG    color;                          //  color code: 0=normal, 1=reverse, 2=err_msg
        UCHAR   *msg ;                          //  text to display
};


#define GD_DSP struct data_display_text         //  Abbreviation
GD_DSP
{
        RC      row  ;                          //  row to display text
        RC      col  ;                          //  column to display text
        COL     fg   ;                          //  foreground color
        COL     bg   ;                          //  background color
        UCHAR   *msg ;                          //  text to display
};


//      GD menu definitions

#define SLASH_MENU_TYPE         0
#define PULLDOWN_MENU_TYPE      1


//      Prototypes
INT16   fs_CheckIfDone(INT16 key,INT16 done,INT16 a_esc,INT16 a_fk,INT16 a_cfk,INT16 a_sfk,INT16 a_afk);
void    fs_CursorOn(void);
FLAG    fs_disp_prompt_(GD_DEF *fld);
INT16   fs_GetChar(INT16 *done);
FLAG    fs_gets_(GD_DEF *fld);
FLAG    fs_gets_number_(GD_DEF *fld);
INT16   fs_HelpMessage(INT16 key,STRING msg,INT16 force);
FLAG    fs_validate_(GD_DEF *fld);
FLAG    fs_val_chars_(UCHAR str[],INT16 dtyp,INT16 dsubtyp,INT16 flen);
INT16   fs_val_fld_(GD_DEF *fld);
void    sc_write_data(GD_DSP form[]);
INT16   SDF_Allocate_Init(GD_DEF *fld[],GD_DEH *fhdr,INT16 num);
INT16   SDF_Disk_Write_Field(GD_DEF *fld);
INT16   SDF_Disk_Write_Form(GD_DEF *fld[],GD_DEH *fhdr);
INT16   SDF_Disk_Write_F_Hdr(GD_DEH *hdr);
void    SDF_Init_Field(GD_DEF *fld,INT16 fnumber);
INT16   SDF_Init_Form(GD_DEF *fld[],GD_DEH *fhdr,INT16 no_of_fields,UCHAR fmname[],UCHAR flname[]);
INT16   SDF_Init_Global(void);
FLAG    SDF_Read_Field(GD_DEF *fld);
INT16   SDF_Read_Form(GD_DEF *fld[],GD_DEH *fhdr);
INT16   SDF_Remove_Form(GD_DEF *fld[],GD_DEH *fhdr);
FLAG    SDF_Write_Field(GD_DEF *fld);
INT16   SDF_Write_Form(GD_DEF *fld[],GD_DEH *fhdr);
void    SDF_write_screen(GD_DET form[]);


//      Macros
                        //  swap foreground and background bits
#define SWAP_ATTR(a)    ((ATTR) (((((((a)>>4)&0x07)|(((a)<<4)&0x70))|((a)&0x80))|((a)&0x08))))


#endif  // avoid duplicate definition
