//<t>   Header file for GD tools RS-232 functions

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_SER_H_
#define _DEFD_GD_SER_H_ 1


#define RS_232                          struct gd_RS_232_struct
RS_232
{
        INT16   port       ;            //  0 through 7
        UINT16  baud       ;            //  110 - 9600
        UINT16  parity     ;            //  0=none, 1=odd, 2=even
        UINT16  data_bits  ;            //  7 or 8
        UINT16  stop_bits  ;            //  1 or 2
        INT16   loc_echo   ;            //  ON or OFF
};

//      The next four items are ORed together to initialize the COM port.

#define COM_BAUD_110    0               //  baud rate
#define COM_BAUD_150    32
#define COM_BAUD_300    64
#define COM_BAUD_600    96
#define COM_BAUD_1200   128
#define COM_BAUD_2400   160
#define COM_BAUD_4800   192
#define COM_BAUD_9600   224

#define COM_PAR_NONE    0               //  parity
#define COM_PAR_ODD     8
#define COM_PAR_EVEN    24

#define COM_DBITS_7     2               //  data bits
#define COM_DBITS_8     3

#define COM_SBITS_1     0               //  stop bits
#define COM_SBITS_2     4


// FLAG    modem_init(INT16 type);
// INT16   ser_port_aborted(void);
// INT16   ser_port_getch(UCHAR *c);
// INT16   ser_port_init(INT16 port,UINT16 baud,INT16 parity,INT16 d_bits,INT16 s_bits,INT16 local_echo);
// INT16   ser_port_putbuf(UCHAR *b,INT16 n);
// INT16   ser_port_putch(UCHAR c);
// INT16   ser_port_puts(UCHAR *s);
// UINT16  ser_port_status(void);


#endif  // avoid duplicate definition
