//<t>   Header File for GD Tools Functions

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.

//      This file may NOT be disclosed to anyone without permission of the
//      author.


#ifndef _DEFD_GD_TOOLS_H_
#define _DEFD_GD_TOOLS_H_ 1


#define _THE_COMPANY_NAME_      "Danen Information Services"
// #define _THE_COMPANY_NAME_   "Gerry J. Danen"
#define _THE_COPR_YEAR_         "1998"          // for copyright notices
#define _THE_COPR_YEAR_SHORT_   "98"            // for copyright notices


//      set flag below to 1 for Windows 0 for non-Windows
#define WINDOZE_VERSION 0
#if WINDOZE_VERSION
#pragma message ("Windows version")
#endif


#ifdef __cplusplus
  extern "C" {
#endif

#ifdef  __cplusplus
  #define INLINE inline
#else
  #define INLINE __inline
#endif

#define CDECL __cdecl
#define FAR   __far
#define NEAR  __near

#ifndef LINT_ARGS
  #define LINT_ARGS 1
#endif

#pragma pack(1)


#include"gd_model.h"
#include"gd_shwar.h"
#include<stdlib.h>
#include<stdio.h>
#include<conio.h>
#include<ctype.h>
#include<malloc.h>
#include<string.h>
#include<dos.h>
#include<time.h>
#include<types.h>
#include<direct.h>
#include"gd_macs.h"
#include"gd_who.h"
#include"ms_struc.h"


typedef struct gd_equip_info_struct_            // BIOS equipment structure
{
    UINT        screen_adapter ;                // 1=Graphics, 0=Monochrome
    UINT        diskette_drives ;               // # of diskette drives
    UINT        s_b_ram_banks ;                 // Banks of memory on system board
    UINT        total_mem_size ;                // Total available RAM
    UINT        ser_ports ;                     // # of ports
    UINT        par_ports ;                     // # of ports
    BOOL        math_coprocessor ;              // True/False
    BOOL        game_adapter ;                  // True/False
    BOOL        internal_modem ;                // True/False
    BOOL        DMA_chip ;                      // True/False
}   equipment_t ;


typedef struct gd_drive_parameters_struct_      // disk drive parameters
{
    unsigned    drive ;
    unsigned    status ;
    unsigned    no_drives ;
    unsigned    max_head_number ;
    unsigned    max_cyl_number ;
    unsigned    max_sector_number ;
    unsigned    sector_size ;
}   drive_param_t ;


typedef struct gd_video_struct_
{
//#define vid_CONFIG_EV   "GD.VIDEO.CFG"  // env.var where to find the video cfg file
//#define vid_CONFIG_FILE "GD_VIDEO.CFG"  // name of the video cfg file
#define vid_IDMARKER_1  "&Vcfg"
#define vid_IDMARKER_2  "Danen"
#define vid_ID_VERSION  1
        UCHAR   ident1[6]  ;            // identification marker
        int     version    ;            // version of structure
        WORD16  vbuf_addr  ;            // address of video buffer
        INT16   adapter    ;            // 0=mono, 1=CGA
        INT16   mode       ;            // 0 through ..
        INT16   cur_page   ;            // 0 through 7
        BOOL    is_color   ;            // is in color mode
        BOOL    is_mono    ;            // is current display a monochrome? T/F
        BOOL    is_cga     ;            // is current display a CGA?  T/F
        BOOL    is_vga     ;            // is current display a VGA?  T/F
        BOOL    is_ega     ;            // is current display an EGA? T/F
        INT16   ega_memory ;            // 64K, 128K, 192K, or 256K
        INT16   vga_memory ;            // 64K, 128K, 192K, or 256K
        BOOL    first_scr  ;            // first time for NewScreen() ?
        SCHAR   cursor     ;            // 0=hidden, 1=normal, 2=full box, 3=insert(half box)
        SCHAR   cu_scan_1  ;            // cursor scan line 1
        SCHAR   cu_scan_2  ;            // cursor scan line 2
        SCHAR   cu_scan_max;            // maximum cursor scan lines
        RC      rows       ;            // maximum rows that can be shown
        RC      cols       ;            // maximum cols that can be shown
        RC      win_row1   ;            // physical writable screen,
        RC      win_col1   ;            //  usually the whole screen
        RC      win_row2   ;
        RC      win_col2   ;
        RC      top_left_or;            // origin 1=0,0; or 0=1,1
        //  configurable...
        FLAG    io_mode    ;            // 0=direct, 1=BIOS
        BOOL    wait_retrace ;          // wait for retrace? T/F (CGA only)
        RC      msg_row    ;            // display messages on this row
        BOOL    msg_center ;            // center messages?  TRUE/FALSE
        //  colours - configurable...
        COL     border     ;            // border color
        COL     normal_fg  ;            // normal foreground color
        COL     normal_bg  ;            // normal background color
        ATTR    normal_attr;            // normal display attribute fg&bg
        COL     rev_fg     ;            // reverse video foreground color
        COL     rev_bg     ;            // reverse video background color
        ATTR    rev_attr   ;            // rev vid display attribute fg&bg
        COL     err_fg     ;            // error msg foreground color
        COL     err_bg     ;            // error msg background color
        ATTR    err_attr   ;            // error msg attribute fg&bg
        COL     wrn_fg     ;            // warning msg foreground color
        COL     wrn_bg     ;            // warning msg background color
        ATTR    wrn_attr   ;            // warning msg attribute fg&bg
        COL     sts_fg     ;            // status msg foreground color
        COL     sts_bg     ;            // status msg background color
        ATTR    sts_attr   ;            // status msg attribute fg&bg
        COL     hold_fg    ;            // hold msg foreground color
        COL     hold_bg    ;            // hold msg background color
        ATTR    hold_attr  ;            // hold msg attribute fg&bg
        COL     wait_fg    ;            // wait msg foreground color
        COL     wait_bg    ;            // wait msg background color
        ATTR    wait_attr  ;            // wait msg attribute fg&bg
        COL     tt_pgm_fg  ;            // title: pgm name fg color
        COL     tt_time_fg ;            // title: system date/time fg color
        UCHAR   ident2[6]  ;            // identification marker 2
}       video_control_t ;


struct  dreg                            // BLAISE structure
{
        WORD16  ax, bx, cx, dx, si, di, ds, es ;
};
#define DOSREG  struct dreg             //  Abbreviation


struct  segads                          //  BLAISE structure
{                                       //  Offset, segment address type
        WORD16 r;                       //  offset
        WORD16 s;                       //  segment
};
#define ADS     struct segads           //  Abbreviation


typedef struct                          //  struct for message tables
{                                       //  see netlogin.c for sample usage
    int         msgCode ;
    STRING      msgText ;
}   message_table_t ;


#include "gd_files.h"
#include "gd_fdefs.h"


#ifdef __cplusplus
  }
#endif
#endif  // avoid duplicate definition
