//<t>   Header file for Window Applications

//<c>   Copyright 1980-1998 by Gerry J. Danen; all rights reserved.


#ifndef _DEFD_GD_WN_H_
#define _DEFD_GD_WN_H_ 1


typedef struct  gd_win_struct
{
        INT16   whandle ;       //  window handle
                                //  coordinates of usable window area
        RC      trow    ;       //  top/left row
        RC      lcol    ;       //  top/left column
        RC      brow    ;       //  bottom/right row
        RC      rcol    ;       //  bottom/right column
                                //  border coordinates, if no border then
                                //  these coordinates are the same as above
        RC      b_trow  ;       //  border top/left row
        RC      b_lcol  ;       //  border top/left column
        RC      b_brow  ;       //  border bottom/right row
        RC      b_rcol  ;       //  border bottom/right column
        RC      row     ;       //  cursor is at row
        RC      col     ;       //  cursor is at column
        RC      ht      ;       //  window height in usable lines
        RC      wd      ;       //  window width in usable columns
        RC      topline ;       //  top text line
        RC      lines   ;       //  total text lines
        FLAG    hasbord ;       //  has a border?  YES or NO
        FLAG    do_wrap ;       //  wrap-around within window: YES or NO
        FLAG    insert  ;       //  insert mode: TRUE or FALSE
        FLAG    save_it ;       //  save original video image?
        COL     b_fg    ;       //  border color for this window
        COL     b_bg    ;       //  border color for this window
        COL     fg      ;       //  foreground color for window
        COL     bg      ;       //  background color for window
        ATTR    b_attr  ;       //  border attr. for this window
        ATTR    attr    ;       //  display attribute fg&bg
        UCHAR   *save_or;       //  video image before wn was created
        UCHAR   *save_wn;       //  image of window when made inactive
        UCHAR   **text  ;       //  pointer to text (used by text editor)
}       WIND ;


typedef struct  wn_menu_struct
{
        UCHAR   *mname  ;       //  menu bar selection names
        UCHAR   *mhlpmsg;       //  menu bar prompting messages
        UCHAR   **mselcs;       //  the pop-down menu selections
        UCHAR   **mshelp;       //  help mnemonics for the pop down selections
        INT16   *mskeys ;       //  key strokes that accompany the selections
        INT16   (**func)(INT16,INT16); // the functions to execute for the selections
        INT16   lastvsel;       //  most recent vertical selection
}       MENU ;


typedef struct  wn_field_struct // data entry field description
{
        RC      frow    ;       //  field row
        RC      fcol    ;       //  field column position
        RC      fx      ;       //  running column
        UCHAR   *fbuff  ;       //  field buffer
        UCHAR   *fmask  ;       //  field data entry mask
        UCHAR   *fhelp  ;       //  field help window mnemonic
}       FIELD ;


//      Prototypes
void    mn_bar_remove(UCHAR *mb);
UCHAR * mn_bar_show(MENU *mn);
void    mn_select(MENU *mnn,INT16 sel);
INT16   MoveCursRelative(INT16 direction,INT16 count,WIND *wn);

void    wn_clr_cur_line(WIND *wn);
void    wn_clr_eol(void);
void    wn_clr_to_end_of_line(WIND *wn);
void    wn_cls(void);
RC      wn_col(void);
void    wn_Color(INT16 fg,INT16 bg,WIND *wn);
INT16   wn_create(RC top,RC left,RC bot,RC right,COL fg,COL bg,COL bfg,COL bbg,BOOL hasborder,BOOL wrap,BOOL save);
void    wn_curs(RC row,RC col);
void    wn_CursOn(WIND *wn);
void    wn_curs_size(INT16 state);
void    wn_err_msg(INT16 errtype,STRING fmt,...);
INT16   wn_getkey(void);
INT16   wn_GetLine(FLAG which,RC row,RC col,COL fgr,COL bgr,INT16 len,BOOL upcase,UCHAR *data,UCHAR *help);
void    wn_GetLineInit(UCHAR which,UCHAR yesno);
INT16   wn_get_a_key(INT16 *done,WIND *wn);
void    wn_go_beg_line(WIND *wn);
void    wn_go_end_line(WIND *wn);
void    wn_Init_old_(RC trow,RC lcol,RC brow,RC rcol,BOOL hasbord,COL b_fg,COL b_bg,COL fg,COL bg,BOOL wrap,WIND *wn);
void    wn_key_bspace_(WIND *wn);
void    wn_key_delete_(WIND *wn);
void    wn_key_insert_(INT16 key,WIND *wn);
void    wn_key_output(INT16 key,WIND *wn);
void    wn_key_replace_(INT16 key,WIND *wn);
void    wn_make_current(void);
void    wn_MoveCurs(INT16 direction,INT16 count,WIND *wn);
void    wn_MoveCursor(RC row,RC col,WIND *wn);
void    wn_msg_cent(RC row,STRING str);
void    wn_msg_ljust(RC row,STRING str);
void    wn_msg_rjust(RC row,STRING str);
void    wn_paint(void);
void    wn_remove(void);
INT16   wn_retrieve_line(WIND *wn);
RC      wn_row(void);
void    wn_scroll_down(RC n);
void    wn_scroll_up(RC n);
void    wn_set_bounds(RC top_row,RC lf_col,RC bot_row,RC rt_col);
void    wn_set_color(COL fg,COL bg);
void    wn_title_bot(INT16 where,STRING ttl);
void    wn_title_top(INT16 where,STRING ttl);
void    wn_wr_str(RC row,RC col,STRING fmt,...);


// // INT16   de_enter_data(FIELD *,INT16,INT16);
// // void    de_clear_fields(void);
// // void    de_show_fields(void);


//      external stuff

extern  INT16   wn_helpkey_ ;           //  user-definable helpkey
extern  void    (*wn_helpfun_)(void);   //  user-definable helpfunction
extern  WIND    wnx[] ;                 //  window table
extern  WIND    wkwn ;                  //  a working window structure

extern  INT16   mn_in_menu ;
extern  INT16   wn_editing_ ;


//      window colors

extern  COL     wn_menu_fg_     ;       //  menus
extern  COL     wn_menu_bg_     ;
extern  COL     wn_menu_sel_fg_ ;       //  menu selector bars
extern  COL     wn_menu_sel_bg_ ;
extern  COL     wn_entry_fg_    ;       //  data entry windows
extern  COL     wn_entry_bg_    ;
extern  COL     wn_entry_fld_fg_;       //  data entry fields
extern  COL     wn_entry_fld_bg_;


//      for "help" windows

#define SET_HELP(s)     help_mnemonic_=s
extern  UCHAR   *help_mnemonic_ ;
void    load_helpfile(UCHAR *hn);
void    show_help_from_file(void);


#define INIT_INSERT_STATE       FALSE   // initial Insert mode


#endif  // avoid duplicate definition
