//      Various data structures for use with Microsoft MS-DOS function calls

#ifndef _DEF_MS_STRUC_
#define _DEF_MS_STRUC_  1


//      Macros & values used in interpreting FAT entries

#define AVAILABLE               0x0000
#define MAX_12BIT               0x0FF6
#define LOCKED_OUT(IS12)        (IS12 ? 0x0FF7 : 0xFFF7)
#define LAST_CLUSTER(IS12)      (IS12 ? 0xFFF  : 0xFFFF)


//      ms_date -- packed date format used in directory

struct  MS_DATE_STRUCT_
{
    unsigned d : 5 ;
    unsigned m : 4 ;
    unsigned y : 7 ;                            // max 127, with 1980 offset, good to 2107
};
typedef struct MS_DATE_STRUCT_ ms_date_t ;



//      ms_time -- packed time format used in directory

struct  MS_TIME_STRUCT_
{
    unsigned xx : 5 ;
    unsigned mm : 6 ;
    unsigned hh : 5 ;
};
typedef struct MS_TIME_STRUCT_ ms_time_t ;


//      extended_header -- header used in constructing an extended file control block.

struct  extended_header
{
    unsigned char header ;
    char zeros[5] ;
    char attrib ;
};


//      ext_fcb -- extended file control block

struct  EXTENDED_FCB_STRUCT_
{
    struct   extended_header fcb_hdr ;
    char     drive_id ;
    char     file_name[8] ;
    char     file_extension[3] ;
    unsigned curblok ;
    unsigned recsize ;
    long     file_size ;
    ms_date_t date ;
    ms_time_t time ;
    char     reserved[8] ;
    char     rec_in_blok ;
    long     rel_record ;
};
typedef struct EXTENDED_FCB_STRUCT_ e_fcb_t ;


//      entry -- directory entry structure

struct  entry
{
    char     drive_no ;
    char     filname[11] ;
    char     attributes ;
    char     unused[10] ;
    ms_time_t create_time ;
    ms_date_t create_date ;
    unsigned first_cluster ;
    long     filsize ;
};


//      extended_entry -- directory structure for use with extended file search

struct  extended_entry
{
    struct extended_header dir_hdr ;
    struct entry           body ;
};


struct  IOCTL_MEDIA_ID_STRUCT_
{
        unsigned int  info_level ;
        unsigned int  serial2, serial1 ;
        unsigned char vlabel[11] ;
        unsigned char fst[8] ;
};
typedef struct IOCTL_MEDIA_ID_STRUCT_ mid_t ;


struct  IOCTL_SPECIAL_FUNC_STRUCT_
{
        unsigned char sfFunction ;
        unsigned char sfAccessFlg ;             // 0 = access blocked, "unformatted"
};
typedef struct IOCTL_SPECIAL_FUNC_STRUCT_ specfunc_t ;


#endif  // #ifndef _DEF_MS_STRUC_
